VERSION 5.00
Begin VB.Form frmSelectEvents 
   Caption         =   "Select Events for Calendar"
   ClientHeight    =   4155
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8535
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4155
   ScaleWidth      =   8535
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   495
      Left            =   3240
      TabIndex        =   7
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton cmdRemoveAll 
      Caption         =   "<<"
      Height          =   495
      Left            =   3600
      TabIndex        =   6
      ToolTipText     =   "Remove all events from the calendar"
      Top             =   2520
      Width           =   1215
   End
   Begin VB.CommandButton cmdRemoveOne 
      Caption         =   "<"
      Height          =   495
      Left            =   3600
      TabIndex        =   5
      ToolTipText     =   "Remove selected events from calendar"
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddOne 
      Caption         =   ">"
      Height          =   495
      Left            =   3600
      TabIndex        =   4
      ToolTipText     =   "Include the selected events"
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddAll 
      Caption         =   ">>"
      Height          =   495
      Left            =   3600
      TabIndex        =   3
      ToolTipText     =   "Include all events"
      Top             =   720
      Width           =   1215
   End
   Begin VB.ListBox lstInclude 
      Height          =   2205
      Left            =   5160
      MultiSelect     =   2  'Extended
      TabIndex        =   2
      Top             =   720
      Width           =   3255
   End
   Begin VB.ListBox lstExclude 
      Height          =   2205
      Left            =   240
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   720
      Width           =   3135
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Include these events"
      Height          =   255
      Left            =   4800
      TabIndex        =   9
      Top             =   480
      Width           =   2775
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Don't include these events"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   480
      Width           =   2775
   End
   Begin VB.Label lblHelp 
      Alignment       =   2  'Center
      Caption         =   "Select the events you want included in your calendar, then click 'Done'"
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   7815
   End
End
Attribute VB_Name = "frmSelectEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim FirstTime As Boolean

Private Sub cmdAddAll_Click()
    ' move all events from exclude to include
    Do While lstExclude.ListCount > 0
        lstInclude.AddItem lstExclude.List(0)
        lstInclude.ItemData(0) = lstExclude.ItemData(0)
        lstExclude.RemoveItem (0)
    Loop
End Sub

Private Sub cmdAddOne_Click()
    Dim i As Integer
    Dim SelectedEvents(MaxEvents)
    Dim NumSelected As Integer
    Dim ndx As Integer
    
    ' build list of selected items
    For i = 0 To lstExclude.ListCount - 1
        If lstExclude.Selected(i) Then
            SelectedEvents(NumSelected) = i
            NumSelected = NumSelected + 1
        End If
    Next
    
    ' move all selected items to include
    For i = 0 To NumSelected - 1
        ndx = SelectedEvents(i)
        lstInclude.AddItem lstExclude.List(ndx - i)
        lstInclude.ItemData(lstInclude.NewIndex) = lstExclude.ItemData(ndx - i)
        lstExclude.RemoveItem (ndx - i)
    Next
    
End Sub

Private Sub cmdDone_Click()
    If lstInclude.ListCount > 0 Then
        load_events
    Else
        MsgBox "No events were selected to be included.  If you create a calendar, it will have all events", vbOKOnly, "Nothing Selected"
    End If
    Unload Me
End Sub

Private Sub cmdRemoveAll_Click()
    init_form
End Sub

Private Sub cmdRemoveOne_Click()
    Dim i As Integer
    Dim SelectedEvents(MaxEvents) As Integer
    Dim NumSelected As Integer
    Dim ndx As Integer
    
    ' build list of items to be removed
    For i = 0 To lstInclude.ListCount - 1
        If lstInclude.Selected(i) Then
            ' selected - add to list
            SelectedEvents(NumSelected) = i
            NumSelected = NumSelected + 1
        End If
    Next
    
    ' move selected items from include to exclude
    For i = 0 To NumSelected - 1
        ndx = SelectedEvents(i)
        lstExclude.AddItem lstInclude.List(ndx - i)
        lstExclude.ItemData(lstExclude.NewIndex) = lstInclude.ItemData(ndx - i)
        lstInclude.RemoveItem (ndx - i)
    Next

    ' we now have a list, move items from included to excluded
    
End Sub

Private Sub Form_Activate()
    If FirstTime Then
        init_form
        FirstTime = False
    End If
End Sub

Private Sub Form_Load()
    FirstTime = True
    Me.Width = mdiStakeCal.Width - 500
    Me.Height = mdiStakeCal.Height - 1000
End Sub
Sub init_form()
    Dim sql As String
    Dim rsCal As ADODB.Recordset
    Dim strDate As String
    Dim strEvent As String
    Dim s As String
    Dim s2 As String
    Dim ID As Long
    
    ' clear both list boxes
    lstInclude.Clear
    lstExclude.Clear
    
    s = BuildEventWhere()
    If Len(s) > 0 Then
        s = s & " and "
    End If
    
    s2 = BuildUnitWhere()
    If Len(s2) > 0 Then
        s2 = s2 & " and "
    End If
    
    sql = "select * from " & TableName & " where " _
        & s & " EventDate >= Now()" _
        & " order by EventDate"
    Set rsCal = New ADODB.Recordset
    rsCal.Open sql, dbConnection, , , adCmdText
    
    Do While Not rsCal.EOF
        strDate = rsCal("EventDate") & ""
        strEvent = rsCal("EventDesc") & ""
        ID = rsCal("ID")
        lstExclude.AddItem strDate & " " & strEvent
        lstExclude.ItemData(lstExclude.NewIndex) = ID
        rsCal.MoveNext
    Loop
    rsCal.Close
    Set rsCal = Nothing
End Sub
Sub load_events()
    ' save selected events for calendar
    
    NumEvents = 0 ' reset counter
    If lstInclude.ListCount = 0 Then
        Exit Sub    ' nothing selected, use all
    End If
    Dim i As Integer
    Dim ID As Long
    
    For i = 0 To lstInclude.ListCount - 1
        SelectedIDs(NumEvents) = lstInclude.ItemData(i)
        NumEvents = NumEvents + 1
    Next
End Sub
